READV(2)

NAME
readv, writev - read or write data into multiple buffers

SYNOPSIS
#include <sys/uio.h>

ssize_t readv(int fd, const struct iovec *vector, int count);

ssize_t writev(int fd, const struct iovec *vector, int count);

DESCRIPTION
The readv() function reads count blocks from the file associated with the file descriptor fd into the multiple buffers described by vector.

The writev() function writes at most count blocks described by vector to the file associated with the file descriptor fd.

The pointer vector points to a struct iovec defined in <sys/uio.h> as

struct iovec {
void *iov_base;   /* Starting address */
size_t iov_len;   /* Number of bytes */
};

Buffers are processed in the order specified.

The readv() function works just like read(2) except that multiple buffers are filled.

The writev() function works just like write(2) except that multiple buffers are written out.

RETURN VALUE
On success, the readv() function returns the number of bytes read; the writev() function returns the number of bytes written. On error, -1 is returned, and errno is set appropriately.

ERRORS
The errors are as given for read(2) and write(2). Additionally the following error is defined.

EINVAL
    The sum of the iov_len values overflows an ssize_t value. Or, the vector count count is zero or greater than MAX_IOVEC.

CONFORMING TO
4.4BSD (the readv and writev functions first appeared in BSD 4.2), Unix98, POSIX 1003.1-2001. Linux libc5 used size_t as the type of the count parameter, and int as return type for these functions.

BUGS
It is not advisable to mix calls to functions like readv() or writev(), which operate on file descriptors, with the functions from the stdio library; the results will be undefined and probably not what you want.

SEE ALSO
read(2), write(2)